Bug 972766 - Warning exception thrown when undeploying Seam application with initialized SFSB
Warning exception thrown when undeploying Seam application with initialized SFSB
Status: CLOSED INSUFFICIENT_DATA
Product: JBoss Enterprise WFK Platform 2
Classification: JBoss
Component: Seam (Show other bugs)
2.3.0
Unspecified Unspecified
unspecified Severity low
: ---
: 2.4.0
Assigned To: Marek Novotny
Marek Schmidt
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-10 10:36 EDT by Tomas Remes
Modified: 2013-07-22 09:17 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-22 09:17:30 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Server debug log with warnings (51.31 KB, text/x-log)
2013-06-11 03:47 EDT, Marek Novotny
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker WFK2-89 Minor New Warning exception thrown when undeploying Seam application with initialized SFSB 2013-09-23 08:17:00 EDT

  None (edit)
Description Tomas Remes 2013-06-10 10:36:42 EDT
Steps to reproduce:

1. Build and deploy e.g. Seam Booking example
2. Login and search for some hotel
3. Undeploy app and notice following exception:

Exception calling stateful session bean default @Remove method: bookingList: java.lang.RuntimeException: java.lang.IllegalStateException
	at org.jboss.as.ejb3.component.interceptors.AdditionalSetupInterceptor.processInvocation(AdditionalSetupInterceptor.java:68) [jboss-as-ejb3-7.2.0.Final-redhat-8.jar:7.2.0.Final-redhat-8]
	at org.jboss.invocation.InterceptorContext.proceed(InterceptorContext.java:288) [jboss-invocation-1.1.1.Final-redhat-2.jar:1.1.1.Final-redhat-2]
	at org.jboss.as.ee.component.TCCLInterceptor.processInvocation(TCCLInterceptor.java:45) [jboss-as-ee-7.2.0.Final-redhat-8.jar:7.2.0.Final-redhat-8]
	at org.jboss.invocation.InterceptorContext.proceed(InterceptorContext.java:288) [jboss-invocation-1.1.1.Final-redhat-2.jar:1.1.1.Final-redhat-2]
	at org.jboss.invocation.ChainedInterceptor.processInvocation(ChainedInterceptor.java:61) [jboss-invocation-1.1.1.Final-redhat-2.jar:1.1.1.Final-redhat-2]
	at org.jboss.as.ee.component.ViewService$View.invoke(ViewService.java:165) [jboss-as-ee-7.2.0.Final-redhat-8.jar:7.2.0.Final-redhat-8]
	at org.jboss.as.ee.component.ViewDescription$1.processInvocation(ViewDescription.java:182) [jboss-as-ee-7.2.0.Final-redhat-8.jar:7.2.0.Final-redhat-8]
	at org.jboss.invocation.InterceptorContext.proceed(InterceptorContext.java:288) [jboss-invocation-1.1.1.Final-redhat-2.jar:1.1.1.Final-redhat-2]
	at org.jboss.as.ejb3.component.stateful.StatefulComponentIdInterceptor.processInvocation(StatefulComponentIdInterceptor.java:52) [jboss-as-ejb3-7.2.0.Final-redhat-8.jar:7.2.0.Final-redhat-8]
	at org.jboss.invocation.InterceptorContext.proceed(InterceptorContext.java:288) [jboss-invocation-1.1.1.Final-redhat-2.jar:1.1.1.Final-redhat-2]
	at org.jboss.invocation.ChainedInterceptor.processInvocation(ChainedInterceptor.java:61) [jboss-invocation-1.1.1.Final-redhat-2.jar:1.1.1.Final-redhat-2]
	at org.jboss.as.ee.component.ProxyInvocationHandler.invoke(ProxyInvocationHandler.java:72) [jboss-as-ee-7.2.0.Final-redhat-8.jar:7.2.0.Final-redhat-8]
	at org.jboss.seam.example.booking.BookingList$$$view51.destroy(Unknown Source) [booking-ejb.jar:]
	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method) [rt.jar:1.7.0_17]
	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:57) [rt.jar:1.7.0_17]
	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43) [rt.jar:1.7.0_17]
	at java.lang.reflect.Method.invoke(Method.java:601) [rt.jar:1.7.0_17]
	at org.jboss.seam.util.Reflections.invoke(Reflections.java:22) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.intercept.RootInvocationContext.proceed(RootInvocationContext.java:32) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.intercept.ClientSideInterceptor$1.proceed(ClientSideInterceptor.java:76) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.intercept.SeamInvocationContext.proceed(SeamInvocationContext.java:56) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.security.SecurityInterceptor.aroundInvoke(SecurityInterceptor.java:163) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.intercept.SeamInvocationContext.proceed(SeamInvocationContext.java:68) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.ejb.RemoveInterceptor.aroundInvoke(RemoveInterceptor.java:43) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.intercept.SeamInvocationContext.proceed(SeamInvocationContext.java:68) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.intercept.RootInterceptor.invoke(RootInterceptor.java:107) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.intercept.ClientSideInterceptor.invoke(ClientSideInterceptor.java:54) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.javassist.tmp.java.lang.Object_$$_javassist_seam_5.destroy(Object_$$_javassist_seam_5.java)
	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method) [rt.jar:1.7.0_17]
	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:57) [rt.jar:1.7.0_17]
	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43) [rt.jar:1.7.0_17]
	at java.lang.reflect.Method.invoke(Method.java:601) [rt.jar:1.7.0_17]
	at org.jboss.seam.util.Reflections.invoke(Reflections.java:22) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.util.Reflections.invokeAndWrap(Reflections.java:144) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.Component.callComponentMethod(Component.java:2307) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.Component.callDefaultRemoveMethod(Component.java:2212) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.Component.destroy(Component.java:1480) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.contexts.Contexts.destroy(Contexts.java:290) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.contexts.Lifecycle.endSession(Lifecycle.java:295) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.contexts.ServletLifecycle.endSession(ServletLifecycle.java:188) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.jboss.seam.servlet.SeamListener.sessionDestroyed(SeamListener.java:59) [jboss-seam.jar:2.3.1.Final-redhat-2]
	at org.apache.catalina.session.StandardSession.expire(StandardSession.java:681) [jbossweb-7.2.0.Final-redhat-1.jar:7.2.0.Final-redhat-1]
	at org.apache.catalina.session.StandardSession.expire(StandardSession.java:644) [jbossweb-7.2.0.Final-redhat-1.jar:7.2.0.Final-redhat-1]
	at org.apache.catalina.session.StandardManager.stop(StandardManager.java:644) [jbossweb-7.2.0.Final-redhat-1.jar:7.2.0.Final-redhat-1]
	at org.apache.catalina.core.StandardContext.stop(StandardContext.java:3916) [jbossweb-7.2.0.Final-redhat-1.jar:7.2.0.Final-redhat-1]
	at org.jboss.as.web.deployment.WebDeploymentService.doStop(WebDeploymentService.java:171) [jboss-as-web-7.2.0.Final-redhat-8.jar:7.2.0.Final-redhat-8]
	at org.jboss.as.web.deployment.WebDeploymentService.access$100(WebDeploymentService.java:60) [jboss-as-web-7.2.0.Final-redhat-8.jar:7.2.0.Final-redhat-8]
	at org.jboss.as.web.deployment.WebDeploymentService$2.run(WebDeploymentService.java:113) [jboss-as-web-7.2.0.Final-redhat-8.jar:7.2.0.Final-redhat-8]
	at java.util.concurrent.Executors$RunnableAdapter.call(Executors.java:471) [rt.jar:1.7.0_17]
	at java.util.concurrent.FutureTask$Sync.innerRun(FutureTask.java:334) [rt.jar:1.7.0_17]
	at java.util.concurrent.FutureTask.run(FutureTask.java:166) [rt.jar:1.7.0_17]
	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1145) [rt.jar:1.7.0_17]
	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:615) [rt.jar:1.7.0_17]
	at java.lang.Thread.run(Thread.java:722) [rt.jar:1.7.0_17]
	at org.jboss.threads.JBossThread.run(JBossThread.java:122)
Caused by: java.lang.IllegalStateException
	at org.jboss.msc.value.InjectedValue.getValue(InjectedValue.java:47)
	at org.jboss.as.connector.deployers.ra.processors.CachedConnectionManagerSetupProcessor$CachedConnectionManagerSetupAction.teardown(CachedConnectionManagerSetupProcessor.java:105)
	at org.jboss.as.ejb3.component.interceptors.AdditionalSetupInterceptor.processInvocation(AdditionalSetupInterceptor.java:62) [jboss-as-ejb3-7.2.0.Final-redhat-8.jar:7.2.0.Final-redhat-8]
	... 54 more


Exception is thrown for every initialized Seam SFSB component. It looks like that similar issues has been solved in the past. (https://issues.jboss.org/browse/JBSEAM-4144, https://issues.jboss.org/browse/JBSEAM-3702)
Comment 1 Marek Novotny 2013-06-10 10:48:41 EDT
Does it help the workaround?

"Do user logout before undeploying."
Comment 3 Tomas Remes 2013-06-11 02:20:25 EDT
Ahh I didn't notice that workaround, but yes it does. When the session is invalidate, then there is no problem during undeployment.
Comment 4 Marek Novotny 2013-06-11 03:47:07 EDT
Created attachment 759449 [details]
Server debug log with warnings

Here is the full log from the issue
Comment 5 Marek Novotny 2013-06-11 03:54:53 EDT
I haven't understand from the description how important/significant error it is.

Now as I reproduced it these exception(s) are just WARNINGs while Seam is destroying Statefull EJBs. This does not  have any consequences on application undeployment. The EJB container just remove the SFSB EJB before Seam is trying to call EJB remove method. Look at line #43 at https://source.jboss.org/browse/Seam/branches/enterprise/WFK-2_1/jboss-seam/src/main/java/org/jboss/seam/ejb/RemoveInterceptor.java?hb=true#to43

This situation is handled properly and final removal of Seam component is done correctly as you can see before WARNING the following log:
09:36:32,201 DEBUG [org.jboss.seam.ejb.RemoveInterceptor] (ServerService Thread Pool -- 71) Stateful component was removed: bookingList

Note You need to log in before you can comment on or make changes to this bug.